// ----------------------------------------------------------
//  ""
// :  ..
// ()   , 2013
// ----------------------------------------------------------

#include "Fft2D.h"

#include <fasttransforms.h>

namespace Holo
{

void Fft2D::CalculateImplace(alglib::complex**& data, int size, bool forward)
{
	alglib::complex_1d_array arr;
	arr.setlength(size);

    // by colomns
    for (int i = 0; i < size; i++)
    {
        // copy data
        for (int j = 0; j < size; j++) arr[j] = data[j][i];
        // 1D-FFT
        if (forward) alglib::fftc1d(arr); else alglib::fftc1dinv(arr);
        // copy back
        for (int j = 0; j < size; j++) data[j][i] = arr[j];
    }

    // by rows
    for (int i = 0; i < size; i++)
    {
        // copy data
        for (int j = 0; j < size; j++) arr[j] = data[i][j];
        // 1D-FFT
        if (forward) alglib::fftc1d(arr); else alglib::fftc1dinv(arr);
        // copy back
        for (int j = 0; j < size; j++) data[i][j] = arr[j];
    }
}

}