// ----------------------------------------------------------
//  ""
// :  ..
// ()   , 2013
// ----------------------------------------------------------

#pragma once

#include <string>
#include <sstream>
#include "ap.h"
#include <FreeImage.h>

namespace Holo
{

class ImageLoader
{
	ImageLoader();
	~ImageLoader();
public:
	enum ClipType { Left, Center, Right };

	static ImageLoader& Instance();

	bool Load(const std::string& filename, double**& data, int& size, std::stringstream& errorStr);
	bool Load(const std::string& filename, double**& data, int preferredSize, int xoffset, int yoffset, std::stringstream& errorStr);
	bool Load(const std::string& filename, double**& data, int preferredSize, ClipType clipType, std::stringstream& errorStr);

	bool Save(const std::string& filename, double** data, int size, bool normalize, double brightness, std::stringstream& errorStr);
	
private:
	FIBITMAP* GenericLoader(const std::string& filename);
	bool Load(FIBITMAP* image, double**& data, int preferredSize, int xoffset, int yoffset, std::stringstream& errorStr);
};

}