// ----------------------------------------------------------
//  ""
// :  ..
// ()   , 2013
// ----------------------------------------------------------

#include "ap.h"

namespace Holo
{

class MatrixHelper
{
public:
	static double Mean(const double** arr, int size)
    {
        double result = 0;
        for (int x = 0; x < size; x++)
        {
            for (int y = 0; y < size; y++) result += arr[x][y];
        }
        result /= (size * size);
        return result;
    }

	template<typename T> static void CyclicShift(T**& arr, int size, int xshift, int yshift)
	{
		T* tmp = new T[size];
		for (int x = 0; x < size; x++)
        {
            for (int y = 0; y < size; y++) tmp[(y + yshift) % size] = arr[x][y];
            for (int y = 0; y < size; y++) arr[x][y] = tmp[y];
        }

		for (int y = 0; y < size; y++)
        {
            for (int x = 0; x < size; x++) tmp[(x + xshift) % size] = arr[x][y];
            for (int x = 0; x < size; x++) arr[x][y] = tmp[x];
        }
		delete [] tmp;
	}

	template<typename T> static void Sum(T**& arr1, T**& arr2, int size)
	{
		for (int x = 0; x < size; x++)
        {
            for (int y = 0; y < size; y++) arr1[x][y] += arr2[x][y];
        }
	}

	template<typename T> static void Mul(T**& arr1, int size, double scalar)
	{
		for (int x = 0; x < size; x++)
        {
            for (int y = 0; y < size; y++) arr1[x][y] *= scalar;
        }
	}
};

}

#define RELEASE_MATRIX(data, size) if (data != 0) { for (int i = 0; i < size; i++) { if (data[i] != 0) delete [] data[i]; } delete [] data; }
