// ----------------------------------------------------------
//  ""
// :  ..
// ()   , 2013
// ----------------------------------------------------------

#include "ReferenceBeam.h"
#include "Constants.h"

namespace Holo
{

void ReferenceBeam::GenerateField(double ccdPixelDist, int sizeInPixel, double angle, alglib::complex**& outputField)
{
    double wavenum = HOLO_2PI / m_waveLength;
    double ccdLen = (sizeInPixel - 1) * ccdPixelDist;

    double ccd = -0.5 * ccdLen;
    for (int i = 0; i < sizeInPixel; i++)
    {
        double phase_angle = -wavenum * sin(angle) * ccd;
        double line_real = cos(phase_angle) * m_intensity;
        double line_imag = sin(phase_angle) * m_intensity;

        for (int j = 0; j < sizeInPixel; j++)
        {
            outputField[i][j].x = line_real;
            outputField[i][j].y = line_imag;
        }

        ccd += ccdPixelDist;
    }
}

}