// ----------------------------------------------------------
//  ""
// :  ..
// ()   , 2013
// ----------------------------------------------------------

#include "Timer.h"

namespace Holo 
{

LARGE_INTEGER Timer::mFrequency;
double Timer::mStartTime = 0.0;
bool Timer::mGlobalStop = 0;	
double Timer::mGlobalStartTime = 0.0;
double Timer::mGlobalStopTime = 0.0;

bool Timer::Init()
{
	if (!QueryPerformanceFrequency(&mFrequency)) return 0;
	mStartTime = 0.0;
	mStartTime = GetRealTime();
	mGlobalStartTime = mGlobalStopTime = 0.0;
	return 1;
}

Timer::Timer()
{
	mTime = 0.0;
	mStoped = 1;
}

double Timer::GetRealTime()
{
	LARGE_INTEGER nTime;
	QueryPerformanceCounter(&nTime);
	if (mGlobalStop) return mGlobalStopTime;
	return (double(nTime.QuadPart)/(double)mFrequency.QuadPart)-mStartTime + mGlobalStopTime - mGlobalStartTime ;
}

void Timer::StopAll()
{
	if (mGlobalStop) return;
	mGlobalStopTime = GetRealTime();
	mGlobalStop = 1;
}

void Timer::StartAll()
{
	if (!mGlobalStop) return;
	LARGE_INTEGER nTime;
	QueryPerformanceCounter(&nTime);
	mGlobalStartTime = (double(nTime.QuadPart)/(double)mFrequency.QuadPart)-mStartTime;
	mGlobalStop = 0;
}

void Timer::Start()
{
	if (!mStoped) return;
	mLocalStartTime = GetRealTime();
	mStoped = 0;
}

void Timer::Stop()
{
	if (mStoped) return;
	mLocalStopTime = GetRealTime();
	mTime = mTime + mLocalStopTime - mLocalStartTime;
	mStoped = 1;
}

double Timer::GetTime()
{
	if (mStoped) return mTime;
	return mTime + GetRealTime() - mLocalStartTime;
}

}