// ----------------------------------------------------------
//  ""
// :  ..
// ()   , 2013
// ----------------------------------------------------------

#pragma once
#include <windows.h>

namespace Holo 
{

class Timer
{
	static LARGE_INTEGER mFrequency;
	static double mStartTime;
	static bool mGlobalStop;
	static double mGlobalStartTime;
	static double mGlobalStopTime;

	double mLocalStartTime;
	double mLocalStopTime;
	double mTime;
	bool mStoped;
public:
	Timer();
	virtual ~Timer(){}

	static bool Init();
	static double GetRealTime();
	static void StopAll();
	static void StartAll();

	virtual void Start();
	virtual void Stop();
	virtual void Clear() { mTime = 0.0; mStoped = 1; }
	virtual double GetTime();
	virtual bool IsStopped(){ return mStoped; }
};

}